#include <algorithm>
#include <map>
#include <iostream>

const int MAX_L = 20;
const int MAX_X = 2000000000;

std::map<std::tuple<int, int, int>, int> h;
char cmd[MAX_L];

int calc(int p, int x) {
  long long int r = 1;
  for(int i = 0; i < p; ++i) {
    if (cmd[i] == '+') r += 1;
    else r *= x;
    if (r > MAX_X) return -1;
  }
  return int(r);
}

void rec(int p) {
  auto k = std::make_tuple(calc(p, 2), calc(p, 3), calc(p, 5));
  if (++h[k] > 1) {
    for (int i = 0; i < p; ++i)
      std::cout << cmd[i];
    std::cout << " " <<
      std::get<0>(k) << " " <<
      std::get<1>(k) << " " <<
      std::get<2>(k) << " " << "\n";
  }
  if (p >= MAX_L) return;
  cmd[p] = '+';
  rec(p + 1);
  cmd[p] = '*';
  rec(p + 1);
}

int main() {
  rec(0);
  for (auto &k: h)
    if (k.second > 1)
      std::cout <<
        std::get<0>(k.first) << " " <<
        std::get<1>(k.first) << " " <<
        std::get<2>(k.first) << " " <<
        //std::get<3>(k.first) << " " <<
        k.second << "\n";
}
