#include <algorithm>
#include <map>
#include <iostream>

const int MAX_L = 20;
const int MAX_X = 2000000000;

char cmd[MAX_L];

int calc(int p, int x) {
  long long int r = 1;
  for(int i = 0; i < p; ++i) {
    if (cmd[i] == '+') r += 1;
    else r *= x;
    if (r > MAX_X) return -1;
  }
  return int(r);
}

const int x[] = { 1, 2, 3, 5 };
int r[4];

void rec(int p) {
  int i = 0;
  for(; i < 4 && calc(p, x[i]) == r[i]; ++i);
  if (i == 4) {
    for (int j = 0; j < p; ++j)
      std::cout << cmd[j];
    std::cout << "\n";
    std::cout.flush();
    exit(0);
  }
  if (p >= MAX_L) return;
  cmd[p] = '+';
  rec(p + 1);
  cmd[p] = '*';
  rec(p + 1);
}

int main() {
  for (int i = 0; i < 4; ++i) {
    std::cout << x[i] << "\n";
    std::cout.flush();
    std::cin >> r[i];
  }

  rec(0);
}
